function [] = ParamGenPSI(M,N,L)
% Training Signal From Shepp Logan Phantom Image and the Initial Operator Generator 
% M = Signal Dimention (square of the image patch size)
% N = Analysis Space Dimention
% L = Training Set Size

% Constrained Analysis Operator Learning for Cosparse Signal Modelling
% Written by Mehrdad Yaghoobi, version 1.0                                    
%     
% Copyright 2013 Mehrdad Yaghoobi, Sangnam Nam, Remi Gribonval and Mike E. Davies
% 
% For all details please refer to README.m
%
% This software is a free software distributed under the terms of the GNU 
% Public License version 3 (http://www.gnu.org/licenses/gpl.txt). You can 
% redistribute it and/or modify it under the terms of this licence, for 
% personal and non-commercial use and research purpose. 

M1 = sqrt(M);
M2 = M1;
A = phantom(512);
[L1,L2] = size(A);
D = randn(M,N);
for i = 1:100,
    D = ProjTF(D);
    D = ProjUNColBall(D);
end
Y(:,1) = 128*ones(M,1);
i = 2;
while i<=L
    r = rand(1,2);
    xb = fix(r(1)*(L1-M1));
    yb = fix(r(2)*(L2-M2));
    Ip = A(xb+1:xb+M1,yb+1:yb+M2);
    v = reshape(Ip,numel(Ip),1);   
    if max(v) ~= min(v),
        Y(:,i) = v;
        i = i+1;
    end
end
save(['ParamPSI','X',num2str(M),'X',num2str(N),'X',num2str(L),'01.mat'],'D','Y') 