function [] = SubGPAOLImageRandRankDeficient(M,N,L,Nu)
% Projected Sub Gradient Rank-deficient Analysis Operator Learning With the Fixed Small Step-size
% M = Signal space dimension
% N = Analysis space dimension
% L = Population of the training samples
% Nu = Null Space of the Operator

% Constrained Analysis Operator Learning for Cosparse Signal Modelling
% Written by Mehrdad Yaghoobi, version 1.0                                    
%     
% Copyright 2013 Mehrdad Yaghoobi, Sangnam Nam, Remi Gribonval and Mike E. Davies
% 
% For all details please refer to README.m
%
% This software is a free software distributed under the terms of the GNU 
% Public License version 3 (http://www.gnu.org/licenses/gpl.txt). You can 
% redistribute it and/or modify it under the terms of this licence, for 
% personal and non-commercial use and research purpose. 

load(['ParamPSI','X',num2str(M),'X',num2str(N),'X',num2str(L),'01.mat'])
Do = D;
[M,N] = size(Do);
[M,L] = size(Y);    
alpha = 1*10^-7;
IN = 100000;

%%% Cancelling the Mean value of Y

Y = double(Y) - ones(M,1)*mean(Y);


%%%% Projection onto the Orthogonal Complement of Nu
nd = min(size(Nu));
Nu = ProjTF(Nu);
ProNPerp = eye(M)- Nu *Nu';
[U,S,V] = svd(ProNPerp);
D = D(1:M-nd,:);
Y = U(:,1:M-nd)'*Y;
for i = 1:100 
    D = ProjTF(D);
    D = ProjUNColBall(D);
end

%%%%% Projected Subgradient 

c = sum(sum(abs(Y'*D)));
cost(1) = c;
for i = 1 : IN
    SG = Y*sign(Y'*D); % This can be replaced by Y*signrand(Y'*D);
    D = D - alpha*SG;  
    D = ProjTF(D);
    D = ProjUNColBall(D);
    c = sum(sum(abs(Y'*D)));
    cost(i+1) = c;
    if mod(i,100) == 0, 
        i 
    end
end
D = (D'*U(:,1:M-nd)')';
save(['ImageAOLRD',num2str(M),'X',num2str(N),'X',num2str(L),'.mat'],'D','Y','Do','cost')