% Synthetic Analysis Operator Recovery Test (Figure 2)

% This experiment may take long to run! You can reduce the number of trial or
% restrict different setting to reduce the computation time. 

% Constrained Analysis Operator Learning for Cosparse Signal Modelling
% Written by Mehrdad Yaghoobi, version 1.0                                    
%     
% Copyright 2013 Mehrdad Yaghoobi, Sangnam Nam, Remi Gribonval and Mike E. Davies
% 
% For all details please refer to README.m
%
% This software is a free software distributed under the terms of the GNU 
% Public License version 3 (http://www.gnu.org/licenses/gpl.txt). You can 
% redistribute it and/or modify it under the terms of this licence, for 
% personal and non-commercial use and research purpose. 

M = 16; % Signal Space Dimension
N = 24; % Analysis Space Dimension
L = N*32; % Training Samples Population
T = 5; % Number of Trial. (10)
r = 1:9; % Cosparsity (1:M-1)
Eps = [0 1 10];

%%%% Exact Recovery Computation with Different Settings

% matlabpool(8);

rr = length(r);
EEps = length(Eps);
% parfor i = 1:rr*EEps       
for i = 1:rr*EEps       
    R = r(fix((i-1)/EEps)+1);
    eps = Eps(mod(i-1,EEps)+1);
    SubGPAOR(M,N,R,L,eps,T)         
end

% matlabpool close;

%%%% Plots of the Results

SAORUnionShow(M,N,L,T,r,Eps)