function [] = SAORUnionShow(M,N,L,T,r,ep)
% Synthetic Analysis Operator Recovery Demonstration in a Single Plot

% M = Signal space dimension
% N = Analysis space dimension
% r = Cosparsities (vector)
% L = Population of the training samples (vector)
% eps = Set of deviations of the starting operator from desired operator (vector)
% T = Number of trials

% Constrained Analysis Operator Learning for Cosparse Signal Modelling
% Written by Mehrdad Yaghoobi, version 1.0                                    
%     
% Copyright 2013 Mehrdad Yaghoobi, Sangnam Nam, Remi Gribonval and Mike E. Davies
% 
% For all details please refer to README.m
%
% This software is a free software distributed under the terms of the GNU 
% Public License version 3 (http://www.gnu.org/licenses/gpl.txt). You can 
% redistribute it and/or modify it under the terms of this licence, for 
% personal and non-commercial use and research purpose. 

rl = length(r);
epl = length(ep);
Err = zeros(epl,rl);
l = 1;

cd Solutions

for i = 1:epl,
    eps = ep(i);
    for j = 1:rl,        
        R = r(j);
        load(['AOR',num2str(R),'X',num2str(M),'X',num2str(N),'X',num2str(L),'X',num2str(eps),'X',num2str(T),'v01.mat'])
        Err(i,j) = sum(err)/T;
    end
end

cd ..

% clf

symb = {'k*','k+','kv'};
linetype = {'k','k-.','k--'};

figure(1)
hold on  
for i = 1:epl
    h = plot(r ,Err(i,:),linetype{i}); 
    set(h,'LineWidth',2)
    h = plot(r ,Err(i,:),symb{i});        
    set(h,'MarkerSize',10)
    grid on
    if i == 1,
        ylabel(['l = ',num2str(L)])
    end
    if l==1, 
        title(['\lambda = ',num2str(ep(i))])
    end    
    ax = axis;
    axis([r(1)-.5 , r(rl)+.5, 0, 102])
end