function Omg = Rowshow(D,sc)
% Showing the rows of an analysis operator as an image, where each image
% block corresponds to the de-vectorised of a row.
% D = Transposed Operator (D = Omega')
% sc = The value for the background image

% Constrained Analysis Operator Learning for Cosparse Signal Modelling
% Written by Mehrdad Yaghoobi, version 1.0                                    
%     
% Copyright 2013 Mehrdad Yaghoobi, Sangnam Nam, Remi Gribonval and Mike E. Davies
% 
% For all details please refer to README.m
%
% This software is a free software distributed under the terms of the GNU 
% Public License version 3 (http://www.gnu.org/licenses/gpl.txt). You can 
% redistribute it and/or modify it under the terms of this licence, for 
% personal and non-commercial use and research purpose. 

[m2,n] = size(D);
m = sqrt(m2);
a = n/m;
mt = m+1;
Omg = sc*ones(a*mt-1,m*mt-1);
for i = 1:n,
    s1 = fix((i-1)/m)+1;
    s2 = mod(i-1,m)+1;
   Omg((s1-1)*mt+1:(s1-1)*mt+m,(s2-1)*mt+1:(s2-1)*mt+m) = reshape(D(:,i),m,m);
end