function [Omegaout,ilcost] = SubGPAOLwLS(X,Omega,IT,alpha)
% Projected Sub Gradient With Line Search
% X = Training data matrix
% Omega = Initial operator
% IT = Iteration number
% alpha : Initial stepsize

% Constrained Analysis Operator Learning for Cosparse Signal Modelling
% Written by Mehrdad Yaghoobi, version 1.0                                    
%     
% Copyright 2013 Mehrdad Yaghoobi, Sangnam Nam, Remi Gribonval and Mike E. Davies
% 
% For all details please refer to README.m
%
% This software is a free software distributed under the terms of the GNU 
% Public License version 3 (http://www.gnu.org/licenses/gpl.txt). You can 
% redistribute it and/or modify it under the terms of this licence, for 
% personal and non-commercial use and research purpose. 

i = 1;
fc = 0;
fl = 0;    
ilcost(1) = f(Omega,X);
while (i<=IT)&&(fl~=1)
%     SG = signrand(Omega*X)*X'; % the most corect gradient but slow to compute     
    SG = sign(Omega*X)*X'; 
    Omeganew = Omega - alpha*SG;
    Omeganew = ProjTF(Omeganew')';
    Omeganew = ProjUNColBall(Omeganew')';    
    c = f(Omeganew,X); % objective value    
    if c < ilcost(i)        
        ilcost(i+1) = c;
        Omega = Omeganew;
        i = i+1;
        fc = 0;
    else
        alpha = alpha/1.5; % modifying the stepsize
        fc = fc + 1;
    if fc >= 8, fl = 1; end % cheking when the maximum number of modifying stepsize is reached
    end
end
Omegaout = ProjTF(Omega')';

function c = f(Omega,X)
c = sum(sum(abs(Omega*X)));